﻿using System;
using System.Runtime.InteropServices;

namespace Utilities {
    public static class Display
    {

        private const uint WM_USER = 0x0400;
        private const uint WM_MSO = WM_USER + 0x0900;
        private const uint WM_MSO_WPARAM_OMFRAMEENABLESHADOW = 0x0075;
        private const uint WM_MSO_LPARAM_SHADOW_DISABLED = 0x0000;
        private const uint WM_MSO_LPARAM_SHADOW_ENABLED = 0x0001;

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern IntPtr SendMessage(
          IntPtr hWnd,
          UInt32 Msg,
          IntPtr wParam,
          IntPtr lParam
        );

        public static void DisableShadows(IntPtr hwndOfficeApp)
        {
            SendMessage(
              hwndOfficeApp,
              (UInt32)WM_MSO,
              (IntPtr)WM_MSO_WPARAM_OMFRAMEENABLESHADOW,
              (IntPtr)WM_MSO_LPARAM_SHADOW_DISABLED
            );
        }

        public static void EnableShadows(IntPtr hwndOfficeApp)
        {
            SendMessage(
              hwndOfficeApp,
              (UInt32)WM_MSO,
              (IntPtr)WM_MSO_WPARAM_OMFRAMEENABLESHADOW,
              (IntPtr)WM_MSO_LPARAM_SHADOW_ENABLED
            );
        }

    }
}

